#!/usr/bin/python3

import subprocess
import os
import shutil
import time

def wakeonlan():
    HOSTNAME = "glotze"
    MAC = "00:22:4D:6A:1D:E1"
    repeat = 15         # Anzahl der Wiederholungen

    for counter in range(1,repeat+1):
        response = os.system("ping -c 1 " + HOSTNAME + ">/dev/null 2>&1")
        if counter > 1:
            time.sleep(25)
        # Kontrolle, ob Rechner erreichbar, ansonsten Aufwecken
        if response == 0:
            print("Verbindung zu '" + HOSTNAME + "' aufgebaut")
            return True
        else:
            print("Keine Verbindung zu '" + HOSTNAME + "' " + str(counter) + ".Wiederholung")
            if counter == 1:
                print("WakeOnLAN ausführen")
                os.popen("wakeonlan %s"%(MAC))
                time.sleep(50)
    return False


def backup():
    SOURCE_MAIN = "icke@glotze:/media/Daten/"
    #SOURCE_LIST = ["Anwendungen", "Audio", "Bilder", "Dokumente", "Projekte", "Videos/Kamera"]
    # Tiefere Verzweigungen wie Videos/Kamera funktionieren nicht, weil dann das Verzeichnis Videos noch nicht angelegt ist
    SOURCE_LIST = ["Anwendungen", "Audio", "Bilder", "Dokumente", "Projekte"]
    TARGET_DIRECTORY = "/media/Daten/Backup/"
    DATE = time.strftime("%Y-%m-%d")
    NUM = 5

    # Backupordner auslesen
    folder_list = []
    for folder in os.listdir(TARGET_DIRECTORY):
        # Nur Ordner zur Liste hinzufügen keine Dateien
        if os.path.isdir(TARGET_DIRECTORY + folder):
            folder_list.append(folder)
    folder_list.sort()
    print("Backupordner Anzahl: ", len(folder_list), " Namen: ", folder_list)
 
    # Kontrolle, ob bereits ein Backup durchgeführt wurde und Datumsordner erstellen
    path = os.path.join(TARGET_DIRECTORY, DATE)
    if len(folder_list) == 0:
        print("ERSTELLE Erstordner ", path)
        os.mkdir(path)
    else:
        # Kontrolle, ob am selben Tag bereits ein Backup durchgeführt wurde
        if folder_list[len(folder_list)-1] == DATE:
            print("BEENDEN Backup", DATE, "heute schon durchgeführt")
            return False
        else:
            print("ERSTELLE Datumsordner ", path)
            os.mkdir(path)
            # Kontrolle, ob maximale Backupanzahl erreicht ist, wenn ja ältestes Löschen
            if len(folder_list) >= NUM:
                del_path = os.path.join(TARGET_DIRECTORY, folder_list[0])
                print("DELETE Ältestes Backup ", del_path, "löschen, mehr als", NUM, "vorhanden")
                shutil.rmtree(del_path)
    
   # Backup durchführen
    for element in SOURCE_LIST:       
        # Kontrolle, ob Verlinkung möglich und Zielverzeichnis existiert
        link = ""
        if len(folder_list) >= 1:
            path = TARGET_DIRECTORY + folder_list[len(folder_list)-2] + "/" + element
            if os.path.isdir(path) == True:
                link = "--link-dest=" + TARGET_DIRECTORY + folder_list[len(folder_list)-2] + "/" + element
                print("LINK einsetzen ", link)
        # Hier müsste eine Abfrage rein, die prüft, ob es sich um ein Unterverzeichnis handelt, wie bei Videos/Kamera
        rsynccmd = "rsync -a --progress --delete " + link + " -e ssh " + SOURCE_MAIN + element + "/ " + os.path.join(TARGET_DIRECTORY,DATE+"/") + element + "/"
        print("KOMMANDO: ", rsynccmd)
        subprocess.call(rsynccmd, shell=True)

    return True

# main program
host_awake = wakeonlan()
if host_awake == True:
    backup()

# IDEEN
# - Backup auch am selben Tag bei Änderungen nochmal ausführen, wie erkennt man die Änderungen an der SOURCE_LIST mit Verzeichnissen vergleichen
# - Backup eines Unterverzeichnisses
# - Kontrolle, ob Backup erfolgreich durchgeführt wurde -> Protokoll senden
